# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic
import typing_extensions

from ...core.datetime_utils import serialize_datetime
from ..util.with_embedding_type import WithEmbeddingType


class SearchRequest(WithEmbeddingType):
    query: str = pydantic.Field(description=("Query for search\n"))
    max_content_size: typing.Optional[int] = pydantic.Field(description=("Max number of search (Default: 1000)\n"))
    tags: typing.Optional[typing.List[str]]

    class Partial(WithEmbeddingType.Partial):
        query: typing_extensions.NotRequired[str]
        max_content_size: typing_extensions.NotRequired[typing.Optional[int]]
        tags: typing_extensions.NotRequired[typing.Optional[typing.List[str]]]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
