# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic
import typing_extensions

from ...core.datetime_utils import serialize_datetime
from ..util.document_id import DocumentId
from ..util.source import Source
from .embedding_status import EmbeddingStatus


class DocumentResponse(pydantic.BaseModel):
    document_id: DocumentId
    source: Source
    name: str
    num_chunks: int
    tags: typing.List[str]
    embeddings: typing.List[EmbeddingStatus]

    class Partial(typing_extensions.TypedDict):
        document_id: typing_extensions.NotRequired[DocumentId]
        source: typing_extensions.NotRequired[Source]
        name: typing_extensions.NotRequired[str]
        num_chunks: typing_extensions.NotRequired[int]
        tags: typing_extensions.NotRequired[typing.List[str]]
        embeddings: typing_extensions.NotRequired[typing.List[EmbeddingStatus]]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        json_encoders = {dt.datetime: serialize_datetime}
